Help us improve your experience.

Let us know what you think.

Do you have time for a two-minute survey?

Navigation
Guide That Contains This Content
[+] Expand All
[-] Collapse All

    Upgrading Contrail Software from Release 2.00 or Greater to Release 2.20

    Use the following procedure to upgrade an installation of Contrail software from one release to a more recent release. This procedure is valid starting from Contrail Release 2.00 and greater.

    Note: If you are installing Contrail for the first time, refer to the full documentation and installation instructions in Installing the Operating System and Contrail Packages.

    Instructions are given for both CentOS and Ubuntu versions. The only Ubuntu versions supported for upgrading are Ubuntu 12.04 and 14.04.2.

    To upgrade Contrail software from Contrail Release 2.00 or greater:

    1. Download the file contrail-install-packages-x.xx-xxx.xxx.noarch.rpm | deb from https://www.juniper.net/support/downloads/?p=contrail#sw and copy it to the /tmp directory on the config node, as follows:

      CentOS : scp <id@server>:/path/to/contrail-install-packages-x.xx-xxx.xxx.noarch.rpm /tmp

      Ubuntu : scp <id@server>:/path/to/contrail-install-packages-x.xx-xx~havana_all.deb /tmp

      Note: The variables xxx.-xxx and so on represent the release and build numbers that are present in the name of the installation packages that you download.

    2. Install the contrail-install-packages, using the correct command for your operating system:

      CentOS: yum localinstall /tmp/contrail-install-packages-x.xx-xxx.xxx..noarch.rpm

      Ubuntu: dpkg –i /tmp/contrail-install-packages_x.xx-xxx~icehouse_all.deb

    3. Set up the local repository by running the setup.sh:

      cd /opt/contrail/contrail_packages; ./setup.sh

    4. Ensure that the testbed.py file that was used to set up the cluster with Contrail is intact at /opt/contrail/utils/fabfile/testbeds/.
      • Ensure that testbed.py has been set up with a combined control_data section (required as of Contrail Release 1.10).
      • Ensure that the do_parallel flag is set to True in the testbed.pyfile, see bug 1426522 in Launchpad.net.

      See Populating the Testbed Definitions File.

    5. Upgrade the software, using the correct set of commands to match your operating system and vrouter, as described in the following:

      Change directory to the utils folder:

      cd /opt/contrail/utils; \

      Select the correct upgrade procedure from the following to match your operating system and vrouter. In the following, <from> refers to the currently installed release number, such as 2.0, 2.01, 2.1:

      CentOS Upgrade Procedure:

      fab upgrade_contrail:<from>,/tmp/contrail-install-packages-x.xx-xxx.xxx.noarch.rpm;

      Ubuntu 12.04 Procedure:

      fab upgrade_contrail:<from>,/tmp/contrail-install-packages-x.xx-xxx~icehouse_all.deb;

      Ubuntu 14.04 Upgrade, Two Procedures:

      There are two different upgrade procedures for Ubuntu 14.04 upgrade to Contrail Release 2.20, depending on which vrouter (contrail-vrouter-3.13.0-35-generic or contrail-vrouter-dkms) is installed in your current setup.

      As of Contrail Release 2.20, the recommended kernel version for an Ubuntu 14.04-based system is 3.13.0-40. Both procedures can use the command fab upgrade_kernel_all to upgrade the kernel.

      Ubuntu 14.04 Upgrade Procedure For a System With contrail-vrouter-3.13.0-35-generic:

      Use the following upgrade procedure for Contrail Release 2.20 systems based on Ubuntu 14.04 with the contrail-vrouter-3.13.0-35-generic installed. The command sequence upgrades the kernel version and also reboots the compute nodes when finished.

      fab install_pkg_all:/tmp/contrail-install-packages-x.xx-xxx~icehouse_all.deb;
      
                         fab migrate_compute_kernel;
      
                         fab upgrade_contrail:<from>,/tmp/contrail-install-packages-x.xx-xxx~icehouse_all.deb;
      
                         fab upgrade_kernel_all;
      
                         fab restart_openstack_compute;
      

      Ubuntu 14.04 Upgrade Procedure For System with contrail-vrouter-dkms:

      Use the following upgrade procedure for Contrail R2.20 systems based on Ubuntu 14.04 with contrail-vrouter-dkms instlled. The command sequence upgrades the kernel version and also reboots the compute nodes when finished.

      fab upgrade_contrail:<from>,/tmp/contrail-install-packages-x.xx-xxx~icehouse_all.deb;

      All nodes in the cluster can be upgraded to kernel version 3.13.0-40 by using the following fab command​:

      fab upgrade_kernel_all

    6. On the OpenStack node, soft reboot all of the virtual machines.

      You can do this in the OpenStack dashboard or log into the node that uses the openstack role and issue the following commands:

      • source /etc/contrail/openstackrc ; nova reboot <vm-name>
      • You can also use the following fab command to reboot all virtual machines:

        fab reboot_vm

    7. Check to ensure that the nova-novncproxy service is still running:

      service nova-novncproxy status

      If necessary, restart the service:

      service nova-novncproxy restart

    8. (For Contrail Storage option, only.)

      Contrail Storage has its own packages. 

      To upgrade Contrail Storage, download the file: 

      contrail-storage-packages_x.x-xx*.deb 

      from https://www.juniper.net/support/downloads/?p=contrail#sw

      and copy it to the /tmp directory on the config node, as follows: 

      Ubuntu: scp <id@server>:/path/to/contrail-storage-packages_x.x-xx*.deb  /tmp​

      Note: Use only Icehouse packages (for example, contrail-storage-packages_2.0-22~icehouse_all.deb)  because OpenStack Havana is no longer supported.

      Use the following statement to upgrade the software:

          ​    ​cd /opt/contrail/utils; \     ​ 

      Ubuntu: fab upgrade_storage:<from>,/tmp/contrail-storage-packages_2.0-22~icehouse_all.deb;

      When upgrading to Contrail Release 2.10, add the following steps if you have live migration configured.  Upgrades to Release 2.0 do not require these steps.  Select the command that matches your live migration configuration.

      fab setup_nfs_livem

      or

      fab setup_nfs_livem_global

    Modified: 2015-10-12